#! /usr/bin/python

Version='Version 0.92 (7/1/05)'

# ================= Main SPOT Python Module ======================

import cgitb; cgitb.enable()
import os
import cgi
#import SpotCsv
import SpotTest, SpotParser, SpotData, SpotUtil2, SpotRun

InputVars = {'source':'', 'Check':'', 'Run':'', 'Showfile':'',
             'Test':'', 'MaxRun':'', 'InputFile':'', 'Wordsize':''}
OutputVars = {'source':'', 'maxrun':'', 'inputfile':'', 'messages':'',
              'wordsize':'', 'output':''}

# --------------------- Main --------------------
def Main():
    filename = SpotUtil2.GetHomeDir()+'/SpotEmulator.htm'
    sfile = SpotUtil2.GetFile(filename)
    if sfile == '':
        HTMLOutput("Could not read file: SpotEmulator.htm")
    else:
        Process(sfile)

# ---------------------- HTMLError ---------------
# Prints error message
def HTMLOutput(s):
    print "Content-type: text/html"
    print
    print "<html><body>"+s+"</body></html>"
    
# ---------------------- Process ------------------
# Main processing
def Process(sfile):
    GetInputVars(InputVars)
    ComputeOutputVars(InputVars, OutputVars)     # like source, maxrun and inputfile
    sfile = PlaceOutputVars(sfile,OutputVars)
    HTMLOutput(sfile)
    
# ---------------------- GetInputVars --------------
def GetInputVars(dvars):
    form = cgi.FieldStorage()
    for i in dvars.keys():
        if form.has_key(i):
            dvars[i] = form[i].value

# ---------------------- ComputeOutputVars -----------
# compute the easy vars like source, maxrun and inputfile
def ComputeOutputVars(ivars, ovars):
    # source just slides back in
    ovars['source'] = ivars['source'].strip().replace('\r','')
    
    #  MaxRun has to be formatted, and a default chosen
    keymaxrun = ['100','500','5000','20000']
    itemmaxrun = ['100','500','5,000','20,000']
    s = ''
       # if none was chosen previously, choose the second key
    if ivars['MaxRun'] not in keymaxrun: ivars['MaxRun'] = keymaxrun[1]
    for i in range(len(keymaxrun)):
        s += "<option "
        if keymaxrun[i] == ivars['MaxRun']: s += "selected "
        s += 'value="' + keymaxrun[i] + '">' + itemmaxrun[i] + ' instructions</option>\n'
    ovars['maxrun'] = s

    # Wordsize:
    keywordsize = ['0','4','8','16','32','64']
    itemwordsize = ['no limit','4 bits','8 bits','16 bits','32 bits','64 bits']
    if ivars['Wordsize'] not in keywordsize: ivars['Wordsize']=keywordsize[0]
    s = ''
    for i in range(len(keywordsize)):
        s += "<option "
        if keywordsize[i] == ivars['Wordsize']: s += "selected "
        s += 'value="' + keywordsize[i] + '">' + itemwordsize[i] + '</option>\n'
    ovars['wordsize'] = s
    
    # inputfile: get the list of all files with suffix: ".spotdata"
    l = SpotUtil2.ListFilesWithSuffix(SpotUtil2.HomeDir, '.spotdata')
    if len(l) == 0:
        s = '<option selected>(none)</option>\n'
    else:
        s = '<option>(none)</option>\n'
        for i in l:
            s += '<option '
            if ivars['InputFile'] == (i + '.spotdata'): s += 'selected '
            s += 'value="' + i + '.spotdata">' + i + '</option>\n'
    ovars['inputfile'] = s
    
# Messages -------------------------
    ovars['messages'] = 'No messages.'
    # Test?
    if ivars['Test'] != '':
       if len(l) > 0:
            lstfiles = l[:]
            for i in range(len(lstfiles)):
                lstfiles[i] = lstfiles[i] + ".spotdata"
            ovars['messages'] = SpotTest.testfilelist(lstfiles)
    elif ivars['Showfile'] != '':
        # prevent accessing any files outside the directory
        ifilename = ivars['InputFile']
        if ('/' in ifilename) or ('\\' in ifilename):
            ivars['InputFile'] = '(none)'
            
        if ivars['InputFile'] == '(none)':
            ovars['messages']='<font color=red>Choose an Input Data File other than "(none)"</font>'
        else:
            ifilename = SpotData.FullFilename(SpotUtil2.HomeDir, ivars['InputFile'])
            try:
                f = open(ifilename, 'r')
                lines = f.read()
                f.close()
                lines = lines.replace("\r\n","<br>")
                lines = lines.replace("\r","<br>")
                lines = lines.replace("\n","<br>")
                ovars['messages'] = '<font color=green>'+ifilename+'</font><br>'+lines
            except:
                ovars['messages']='<font color=red>Cannot read file: </font>'+ifilename
                
    else:
        # Check or Run?
        lstlines = ovars['source'].split('\n')
        for i in range(len(lstlines)): lstlines[i] = lstlines[i].strip()
            # check
        err = SpotParser.ParseInstructions(lstlines)
        if err != '':
            ovars['messages'] = "<font color='red'>" + err + "</font>"
        else:
            if ivars['Check'] != '':
                ovars['messages'] = "<font color='green'>OK</font>"
            if ivars['Run'] != '':
                # Get the InputFile
                if ivars['InputFile'] == '(none)':
                    SpotData.ParseCSV('','(none)')
                else:
                    SpotData.ParseCSV(SpotUtil2.HomeDir, ivars['InputFile'])
                # now run
                err,output = SpotRun.SpotExec(SpotParser.lstins, SpotData.InputFile,
                                int(ivars['MaxRun']), int(ivars['Wordsize']), {'version':Version})
                if output == '':
                    ovars['output'] = 'No output.'
                else:
                    ovars['output'] = output
                ovars['messages'] = err
                

    #ovars['output'] = 'No output.'
    
# ----------------------------- PlaceOutputVars --------------------
def PlaceOutputVars(ofile, ovars):
    for i in ovars.keys():
        lookfor = '<!--*' + i + '*-->'
        k = ofile.find(lookfor)
        if k >= 0:
            ofile = ofile[:k] + ovars[i] + ofile[k+len(lookfor):]
    return ofile

# ------------------------------- getVersion -----------------------
def getVersion():
    return Version


Main()



